/* File: $Id: aout.h,v 1.19 1998/02/25 16:17:56 morsiani Exp $ */

/**************************************************************************** 
 *
 * This header file contains constant & macro definitions for .aout/.core 
 * file types.
 * 
 ****************************************************************************/

// default kernel ASID identifier
#define KERNID	0

// BIOS reserved page frames number
#define BIOSPAGES	2

// core file header size in words: core file id tag (1W) + 2 full page frames
// (FRAMESIZE); one for BIOS exclusive use, one for PTE (kernel page table)
#define COREHDRSIZE	((BIOSPAGES * FRAMESIZE) + 1)

// bit masks for kernel memory frames (RW = .data section, EXEC = .text)
#define KERNEXEC	0x200
#define KERNRW	0x600

// PTE table end marker
#define TLBENDTAG 0xFFFFF000

// stack bottom in MIPS memory allocation scheme
#define STACKBOTTOM	0x7FFFEFFC

// .text/.data section starting addresses in MIPS memory allocation scheme
#define TEXTSTART	0x00400000
#define DATASTART	0x10000000


// .aout header entries number and position within header itself
#define AOUTENTNUM 10
#define AOUTTAG	0
#define PROGSTART	1
#define TEXTVSTART	2
#define TEXTVSIZE	3
#define TEXTFOFFS	4
#define TEXTFSIZE	5
#define DATAVSTART	6
#define DATAVSIZE	7
#define DATAFOFFS	8
#define DATAFSIZE	9


