 #$Id: bios.s,v 0.14 1998/02/21 11:02:31 morsiani Exp $

	.abicalls

 # GCC automatic generated header
 
 # GNU C 2.7.2 [AL 1.1, MM 40] Linux/MIPSEL compiled by GNU C

 # Cc1 defaults:
 # -mgas -mabicalls

 # Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
 # -quiet -dumpbase -version -o
 # 

 	# Constants

	# BIOS BREAK codes

	
	getTODHIBCODE	= 0
	getTODLOBCODE	= 1
	getTIMESBCODE 	= 2
	TLBWRBCODE	= 3
	TLBWIBCODE	= 4
	TLBPBCODE	= 5
	TLBRHIBCODE	= 6
	TLBRLOBCODE	= 7
	LDSTBCODE	= 8 
	INTRESTARTBCODE	= 9 
	TLBRESTARTBCODE	= 10
	PRGRESTARTBCODE	= 11
	SYSRESTARTBCODE	= 12	
	PANICBCODE	= 13
	HALTBCODE	= 14

	# miscellaneous

	ASIDMASK	= 0x00000FC0	
	CONTEXTLOWMASK	= 0x000007FF
	BIOSVECTPAGE 	= 0xC0000000
	VECTSIZE	= 136

	
	# NOP padding: 30 nops - string length (32 bytes) 
	PADDING 	= (30 * 4) - 32
	ENDSTRADDR	= 0x80000008
	PANICSTRADDR	= ENDSTRADDR + 16

	TERM0COMMAND	= 0xB000015C
	BUSYCODE	= 3
	BYTELEN 	= 8
	PRINTCHR	= 2	

	TLBENDTAG	= 0xFFFFF000	
	UTLBSTACK	= 0xC0000FFC
	CONTEXTSTART	= 21
	CAUSESTART	= 2
	CAUSEMASK	= 0x1F
	KUPSTATUSMASK	= 0x00000008
	CPU0BITPOS	= 28
	INDEXMASK	= 0x00003F00
	INDEXSTEP	= 0x00000100

	TODHIADDR	= 0xB0000018
	TODLOADDR	= 0xB000001C
	TIMESCALEADDR	= 0xB0000024

	#Code start

	.text
	.align	2
	.globl	bios
	.type	bios,@function
	.ent	bios
bios:
	.frame	$fp,0,$27
	.mask	0x00000000,0
	.fmask	0x00000000,0
	.set noat

	# 0x80000000 address
 	# this is the entry point for UTLB type exceptions: so it sends 
	# them to its proper local handler
	.set noreorder
	.set nomacro
	j	LUTLBHandler
	nop
EndStr:	
	.asciiz	"System halted \n"	
PanicStr:
	.asciiz "kernel panic()\n"
	.space PADDING
	
	# 0x80000080 address: jumps to exception handler
	j	LEXCHandler
	nop
	.set reorder
	.set macro

LPanic:
	# this call prints a message on terminal 0 and loops forever 
	li	$4, PANICSTRADDR - 1

LTermOp:
	li 	$7, TERM0COMMAND
	li 	$8, BUSYCODE

LWaitForReady:
	lw 	$6, -4($7)
	beq	$6, $8, LWaitForReady

LPrintLoop:
	addiu	$4, 1
	lbu	$5, 0($4)

	# char 0 ends the string
	beq	$0, $5, LInfinite
	
	#prepares PRINTCHAR command
	sll 	$5, BYTELEN
	addi	$5, PRINTCHR
	sw	$5, 0($7)

	j	LWaitForReady 

LInfinite:
	j	LInfinite

LHalt:
	# this call prints a message on terminal 0 and loops forever 
	li	$4, ENDSTRADDR - 1
	j 	LTermOp



LUTLBHandler:	
	# this routine handles UTLBL/UTLBS misses
	
	# gets some register work space using bottom of BIOS page frame
	li      $26, UTLBSTACK 
	sw	$4, 0($26)
	sw	$5, -4($26)
	sw	$6, -8($26)
	sw	$7, -12($26)
	
	# save failed VPN + ASID into register $27
	mfc0	$27, $10

	# gets CONTEXT reg 
	mfc0	$5, $4
	srl	$5, CONTEXTSTART

	# now load page table TLB entry and write it to TLB entry 1
	li	$4, BIOSVECTPAGE
	addu	$4, $4, $5
	li	$5, INDEXSTEP
	mtc0	$5, $0
	lw	$6, 0($4)
	lw	$7, 4($4)
	mtc0	$6, $10
	mtc0	$7, $2

	.set noreorder
	.set nomacro
	nop
	tlbwi
	nop
	.set reorder
	.set macro

	# gets PTE starting address
	lw	$7, 8($4)
	
	# sets TLB end marker
	li	$6, TLBENDTAG

	# search loop
LSearchLoop:
	lw 	$5, 0($7)
	beq	$27, $5, LTLBFound
	beq 	$5, $6, LTLBNotFound
	addiu	$7, 8
	j LSearchLoop

LTLBFound:
	# $27 == $5: load $5 with ENTRYLO, store $27 and $5 into TLB,
	# reload registers and return thru $27
	lw	$5, 4($7)
	mtc0	$27, $10
	mtc0	$5, $2

	# this is needed to assure that tlbwr works correctly, since
	# assembler does not see the data dependency between mtc0 and tlb
	# operations
	.set noreorder
	.set nomacro
	nop
	tlbwr
	nop
	.set reorder
	.set macro

	lw	$4, 0($26)
	lw	$5, -4($26)
	lw	$6, -8($26)
	lw	$7, -12($26)
	
	mfc0	$27, $14

	.set noreorder
	.set nomacro
	jr	$27
	rfe
	.set reorder
	.set macro

LTLBNotFound:
	# $5 == $6: table exausted and match not found; reload registers and 
	# ENTRYHI (which is still in $27), and fall thru to default exc handler
	mtc0	$27, $10
	lw	$4, 0($26)
	lw	$5, -4($26)
	lw	$6, -8($26)
	lw	$7, -12($26)
	

LEXCHandler:
	# here starts the general exception handler
	# k0 and k1 registers are always available (never have live
	# values outside BIOS)

	# it must discover the cause of BIOS call, inspecting 
	# the cause register: this is done copying it to $26 and computing
	# the needed value
	mfc0	$26, $13
	srl	$26, CAUSESTART
	andi	$26, $26, CAUSEMASK

	# cause == 0 is interrupt
	beq	$0, $26, LIntHandler
	
	# cause 1-3 is a TLB exception (cause = 2 or 3 and EPC in user
	# space means UTLBHandler has failed)
	addi	$26, -3
	blez	$26, LTLBHandler
	
	#cause 4-7 is a program trap
	addi	$26, -4
	blez	$26, LPRGHandler

	#cause 8 is syscall
	addi	$26, -1
	beq	$0, $26, LSYSHandler

	#cause 9 is break
	addi 	$26, -1
	beq	$0, $26, LBreakHandler
	
	# other causes are program trap
	j	LPRGHandler

LIntHandler:
	# if EPC address is in BIOS area, something in kernel
	# has gone orribly wrong: eg. BIOS running with int unmasked
	# (a big bug for BIOS)
	mfc0	$26, $14
	bltz	$26, LPanic
	# else
	# save processor state into old area and load new state:
	# this is done calling a BIOS subroutine
	li	$27, 0
	j	LSOldLNewArea

LTLBHandler:
	# if EPC address is in BIOS area, something in kernel
	# has gone orribly wrong: eg. page table area corrupted
	# and consequent UTLB handler error
	# (or bug in BIOS)
	mfc0	$26, $14
	bltz	$26, LPanic

	li	$27, 2
	j	LSOldLNewArea

LPRGHandler:
	# if EPC address is in BIOS area, something in kernel or in BIOS
	# has gone orribly wrong (a BIOS bug probably)
	mfc0	$26, $14
	bltz	$26, LPanic

	li	$27, 4
	j	LSOldLNewArea


LSYSHandler:
	# if EPC address is in BIOS area, something in kernel or in BIOS
	# has gone orribly wrong (a BIOS bug probably)
	mfc0	$26, $14
	bltz	$26, LPanic

	li	$27, 6
	j	LSOldLNewArea

LBreakHandler:
	# if EPC address is in BIOS area, something in kernel or in BIOS
	# has gone orribly wrong (a BIOS bug probably)
	mfc0	$26, $14
	bltz	$26, LPanic

	# a BIOS service routine is requested:
	# look into $2 (v0) register for identification
	
	move	$27, $2


	# 0 is getTODHI
	beq     $0, $27, LgetTODHI
	
	addi    $27, -1
	
	# 1 is getTODLO
	beq     $0, $27, LgetTODLO

	addi    $27, -1
	
	# 2 is getTIMESCALE
	beq     $0, $27, LgetTIMESCALE

	addi    $27, -1
	
	# any further BREAK may be executed only in kernel mode, or in 
	# user mode with CPU 0 bit set in STATUS register

	# kernel mode of caller is set when KUP bit in STATUS mask is 0
	mfc0	$26, $12
	andi	$26, $26, KUPSTATUSMASK
	beq	$0, $26, LmayContinue
	j 	LSYSHandler	

	# coprocessor access of caller is set when CPU 0 bit of STATUS mask
	# is set to 1
	mfc0	$26, $12
	srl	$26, CPU0BITPOS
	andi	$26, 0x00000001
	beq	$0, $26, LSYSHandler

LmayContinue:
	# 3 is TLBWR (ENTRYHI, ENTRYLO)
	beq	$0, $27, LTLBWR

	addi    $27, -1
	
	# 4 is TLBWI (ENTRYHI, ENTRYLO, INDEX)
	beq     $0, $27, LTLBWI

	addi    $27, -1

	# 5 is 	TLBP (ENTRYHI, ENTRYLO)
	beq     $0, $27, LTLBP

	addi    $27, -1
	
	# 6 is TLBRHI (INDEX)
	beq     $0, $27, LTLBRHI

	addi    $27, -1

	# 7 is TLBRLO (INDEX)
	beq     $0, $27, LTLBRLO

	addi    $27, -1
	
	# any further break may be executed only in kernel mode
	# kernel mode of caller is set when KUP bit in STATUS mask is 0
	mfc0	$26, $12
	andi	$26, $26, KUPSTATUSMASK
	beq	$0, $26, LisKernel
	j 	LSYSHandler	

LisKernel:
	# 8  is LDST(STATUS, ASID+CONTEXT, PC)
	beq 	$0, $27, LLDST
	
	addi    $27, -1
	
	# 9 is INTRESTART
	beq 	$0, $27, LINTRESTART
	
	addi    $27, -1

	# 10 is TLBRESTART
	beq 	$0, $27, LTLBRESTART
	
	addi    $27, -1

	# 11 is PRGRESTART
	beq 	$0, $27, LPRGRESTART
	
	addi    $27, -1

	# 12 is SYSRESTART
	beq 	$0, $27, LSYSRESTART

	addi    $27, -1

	# 13 is PANIC routine
	beq	$0, $27, LPanic

	addi	$27, -1
	
	# 14 is HALT routine
	beq     $0, $27, LHalt

	
	# any other break is passed up to SYS handler
	j	LSYSHandler


LgetTODHI:
	li 	$26, TODHIADDR
	lw	$2, 0($26)
	j	LReturnFromBreak	 	

LgetTODLO:
	li      $26, TODHIADDR
	lw      $2, 4($26)
	j       LReturnFromBreak

LgetTIMESCALE:
	li	$26, TIMESCALEADDR
	lw      $2, 0($26)
	j       LReturnFromBreak

LTLBWR:
	mfc0	$26, $10
	mfc0	$27, $2
	mtc0	$4, $10
	mtc0	$5, $2

	.set noreorder
	.set nomacro
	nop
	tlbwr
	nop
	.set reorder
	.set macro

	mtc0	$26, $10
	mtc0	$26, $2

	# this function always succeed
	li 	$2, 1
	j       LReturnFromBreak

LTLBWI:
	# first tests provided INDEX to guarantee BIOS safety:
	# if it is == 0 or == 1 (in INDEX format) then operation is 
	# impossible: it would damage BIOS functionality
	move 	$27, $6
	andi	$27, $27, INDEXMASK
	beq 	$0, $27, LinvalidTLBWI
	addi	$27, $27, -INDEXSTEP
	beq	$0, $27, LinvalidTLBWI	
	
	# else operation is valid:

	mfc0 	$26, $10
	mfc0	$27, $2
	mtc0	$4, $10
	mtc0	$5, $2
	mtc0	$6, $0

	.set noreorder
	.set nomacro
	nop
	tlbwi
	nop
	.set reorder
	.set macro

	mtc0	$26, $10
	mtc0	$26, $2
	li 	$2, 1
	j       LReturnFromBreak

LinvalidTLBWI:
	li	$2, 0
	j 	LReturnFromBreak

	
LTLBP:
	# only BIOS can perform this operation without compromising system	
	# state: in $4, $5 are ENTRYLO, ENTRYHI, and in $2 will be returned
	# INDEX register after probe
	
	mfc0	$26, $10
	mfc0	$27, $2
	mtc0	$4, $10
	mtc0	$5, $2
	
	.set noreorder
	.set nomacro
	nop
	tlbp
	nop
	.set reorder
	.set macro
	
	mtc0	$26, $10
	mtc0	$27, $2
	
	mfc0	$2, $0
	j	LReturnFromBreak	

LTLBRHI:
	# here in $4 is INDEX: if wrong format, CP0 INDEX packing
	# will guarantee a valid read: correct index is programmer's business

	mfc0    $26, $10
	mfc0    $27, $2
	mtc0    $4, $0

	.set noreorder
	.set nomacro
	nop
	tlbr
	nop
	.set reorder
	.set macro
	
	# return value in $2
	mfc0	$2, $10	

	mtc0	$26, $10
	mtc0	$27, $2
	j 	LReturnFromBreak	

LTLBRLO:
	# here in $4 is INDEX: if wrong format, CP0 INDEX packing
	# will guarantee a valid read: correct index is programmer's business

	mfc0    $26, $10
	mfc0    $27, $2
	mtc0    $4, $0

	.set noreorder
	.set nomacro
	nop
	tlbr
	nop
	.set reorder
	.set macro
	
	# return value in $2
	mfc0	$2, $2

	mtc0	$26, $10
	mtc0	$27, $2
	j 	LReturnFromBreak	

LLDST:
	# $4 in ENTRYHI and CONTEXT, $5 goes in STATUS, $6 is new PC
	
	# ASID and CONTEXT loading
	mtc0	$4, $10
	mtc0	$4, $4
	
	move 	$27, $5
	# this for BIOS safety
	srl	$27, 2
	sll	$27, 2

	# STATUS loading
	mtc0	$27, $12	
	
	# get new PC and jump
	move 	$27, $6
	
	.set noreorder
	.set nomacro
	jr	$27
	rfe
	.set reorder
	.set macro


LINTRESTART:
	# this means load from OLD area 0		
	li	$26, BIOSVECTPAGE
	j	LLoadStart

LTLBRESTART:
	# this means load from OLD area 1
	li	$26, BIOSVECTPAGE
	addiu	$26, (VECTSIZE * 2)
	j       LLoadStart

LPRGRESTART:
	# this means load from OLD area 2
	li	$26, BIOSVECTPAGE
	addiu	$26, (VECTSIZE * 4)
	j 	LLoadStart

LSYSRESTART:
	# this means load from OLD area 3
	li      $26, BIOSVECTPAGE
	addiu   $26, (VECTSIZE * 6)
	j       LLoadStart


LReturnFromBreak:
	# load back PC and jump
	mfc0	$27, $14
	addiu	$27, 4
	.set noreorder
	.set nomacro
	jr	$27
	rfe
	.set reorder
	.set macro	
 


LSOldLNewArea:
	# this first locates the needed area using $26, then saves the
	# registers and other info
	li	$26, BIOSVECTPAGE

LComputeArea:
	blez	$27, LSave
	addiu	$26, VECTSIZE
	addi	$27, -1
	j 	LComputeArea

LSave:	
	sw	$1, 0($26)
	sw	$2, 4($26)
	sw	$3, 8($26)
	sw 	$4, 12($26)
	sw	$5, 16($26)
	sw	$6, 20($26)
	sw	$7, 24($26)
	sw	$8, 28($26)
	sw	$9, 32($26)
	sw	$10, 36($26)
	sw	$11, 40($26)
	sw	$12, 44($26)
	sw	$13, 48($26) 	
	sw	$14, 52($26)
	sw	$15, 56($26)
	sw	$16, 60($26)
	sw	$17, 64($26)
	sw	$18, 68($26)
	sw	$19, 72($26)
	sw	$20, 76($26)
	sw	$21, 80($26)
	sw	$22, 84($26)
	sw	$23, 88($26)
	sw	$24, 92($26)
	sw	$25, 96($26)

	# $26 and $27 are not saved

	sw	$28, 100($26)
	sw	$29, 104($26)
	sw	$30, 108($26)
	sw	$31, 112($26)
	mfhi	$27
	sw	$27, 116($26)
	mflo	$27
	sw	$27, 120($26)
	# all processor registers saved
	
	# gets ASID part from ENTRYHI register and store in $27
	mfc0	$27, $10
	andi	$27, ASIDMASK
	
	# gets CONTEXT register part and puts it with ASID using $2:
	# this dirties it but it is not a problem, since $2 will be reloaded 
	# soon after 
	mfc0	$2, $4
	srl	$2, CONTEXTSTART
	andi	$2, CONTEXTLOWMASK
	sll	$2, CONTEXTSTART
	or	$27, $2, $27

	# stores them at proper position 
	sw	$27, 124($26)

	# and now save STATUS and EPC registers
	mfc0	$27, $12
	sw	$27, 128($26)
	mfc0    $27, $14
	sw      $27, 132($26)

	# start loading 
	addiu	$26, VECTSIZE

LLoadStart:
	lw	$1, 0($26)
	lw	$2, 4($26)
	lw	$3, 8($26)
	lw 	$4, 12($26)
	lw	$5, 16($26)
	lw	$6, 20($26)
	lw	$7, 24($26)
	lw	$8, 28($26)
	lw	$9, 32($26)
	lw	$10, 36($26)
	lw	$11, 40($26)
	lw	$12, 44($26)
	lw	$13, 48($26) 	
	lw	$14, 52($26)
	lw	$15, 56($26)
	lw	$16, 60($26)
	lw	$17, 64($26)
	lw	$18, 68($26)
	lw	$19, 72($26)
	lw	$20, 76($26)
	lw	$21, 80($26)
	lw	$22, 84($26)
	lw	$23, 88($26)
	lw	$24, 92($26)
	lw	$25, 96($26)

	# $26 and $27 are not saved so they are not loaded too

	lw	$28, 100($26)
	lw	$29, 104($26)
	lw	$30, 108($26)
	lw	$31, 112($26)
	
	lw	$27, 116($26)
	mthi	$27
	lw	$27, 120($26)
	mtlo	$27
	
	# all processor registers loaded (almost)
	
	# storing new ASID and CONTEXT into CP0 registers
	lw	$27, 124($26)
	mtc0	$27, $10
	mtc0	$27, $4
	
	# now load STATUS register
	lw	$27, 128($26)

	# this is for avoiding troubles if STATUS has (erroneously) set bit 0/1
	# it would cause an immediate EXC trap or expose BIOS to interrupts
	srl 	$27, 2
	sll	$27, 2

	mtc0	$27, $12
	
	lw	$27, 132($26)

	# load new PC and jump
	.set noreorder
	.set nomacro
	jr	$27
	rfe
	.set reorder
	.set macro	
	
	.end bios

LbiosEnd:
	.size bios, LbiosEnd - bios
